#include "../array.h"
#include "../fileload.h"
#include <stdlib.h>

/*
 *  byr (Birth Year)
 *  iyr (Issue Year)
 *  eyr (Expiration Year)
 *  hgt (Height)
 *  hcl (Hair Color)
 *  ecl (Eye Color)
 *  pid (Passport ID)
 *  cid (Country ID)
 */

#define BYR 1<<0
#define IYR 1<<1
#define EYR 1<<2
#define HGT 1<<3
#define HCL 1<<4
#define ECL 1<<5
#define PID 1<<6
#define CID 1<<7

typedef struct field{
	int bitcode;
	char label[4];
}field;

int main (int argc, char**argv){
	field fields[8];
	strcpy(fields[0].label, "BYR"); 
	strcpy(fields[1].label, "IYR"); 
	strcpy(fields[2].label, "EYR"); 
	strcpy(fields[3].label, "HGT"); 
	strcpy(fields[4].label, "HCL"); 
	strcpy(fields[5].label, "ECL"); 
	strcpy(fields[6].label, "PID"); 
	strcpy(fields[7].label, "CID"); 

	int all_on = 0;
	for(int i = 0; i<8; i++){
		fields[i].bitcode = 1<<i;
		all_on = all_on | fields[i].bitcode;
		fields[i].label[3] = '\0';
	}

	if(argc < 2){
		printf("not enough inputs\n");
		return -1;
	}
	char * input = file_contents(argv[1]);
	char*dispos = input;

	int n_valids = 0;
	int bitmap_default = 0 | CID;
	int bitmap = 0 | CID;

	char * line= 0;
	char * val = 0;
	char * fieldname = 0;
	while((line = strsep(&dispos, "\n")) != NULL){
		if(strlen(line) == 0) { 
			//printf("Passport done\n");
			if (bitmap == all_on) {
				//printf("Valid passport\n");
				n_valids++;
			}else{
				//printf("Invalid passport\n");
			}
			bitmap = bitmap_default | CID;
			continue;
		}
		while(val =strsep(&line, " ")){
			fieldname = strsep(&val, ":");
			for(int i = 0; i<8; i++){
				if(strcasecmp(fieldname, fields[i].label) == 0){
					bitmap = bitmap | fields[i].bitcode;
					break;
				}
			}
		}
	};
	printf("There are %d valid passports among the bunch.\n", n_valids);
	
	return 0;
}
